# Copyright (c) <2024> NVIDIA CORPORATION & AFFILIATES. All rights reserved.
#
# NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
# property and proprietary rights in and to this material, related
# documentation and any modifications thereto. Any use, reproduction,
# disclosure or distribution of this material and related documentation
# without an express license agreement from NVIDIA CORPORATION or
# its affiliates is strictly prohibited.

#cython: language_level=3

from pyverbs.base cimport PyverbsCM, PyverbsObject
cimport pyverbs.providers.mlx5.libmlx5hws as hws

cdef class HwsContextAttr(PyverbsObject):
    cdef hws.mlx5dv_hws_context_attr attr
    cdef object pd
    cdef object shared_context


cdef class HwsContext(PyverbsCM):
    cdef hws.mlx5dv_hws_context *context
    cdef object ibv_context
    cdef object hws_tables
    cdef object hws_actions
    cdef object hws_resources
    cdef object hws_parser_graph
    cdef add_ref(self, obj)

cdef class HwsQueueOpResult(PyverbsObject):
    cdef hws.mlx5dv_hws_queue_op_result result
