# Copyright (c) <2024> NVIDIA CORPORATION & AFFILIATES. All rights reserved.
#
# NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
# property and proprietary rights in and to this material, related
# documentation and any modifications thereto. Any use, reproduction,
# disclosure or distribution of this material and related documentation
# without an express license agreement from NVIDIA CORPORATION or
# its affiliates is strictly prohibited.

#cython: language_level=3

from pyverbs.providers.mlx5.hws_context cimport HwsContext
from pyverbs.providers.mlx5.hws_item_data cimport HwsData
from pyverbs.base cimport PyverbsCM, PyverbsObject
cimport pyverbs.providers.mlx5.libmlx5hws as hws


cdef class HwsField(PyverbsObject):
    cdef hws.mlx5dv_hws_field field


cdef class HwsItem(PyverbsCM):
    cdef hws.mlx5dv_hws_item item
    cdef object fields
    cdef HwsData data


cdef class HwsMatchTemplateAttr(PyverbsObject):
    cdef hws.mlx5dv_hws_mt_attr attr


cdef class HwsMatchTemplate(PyverbsCM):
    cdef hws.mlx5dv_hws_mt *match_template
    cdef HwsContext hws_context
