# Copyright (c) <2024> NVIDIA CORPORATION & AFFILIATES. All rights reserved.
#
# NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
# property and proprietary rights in and to this material, related
# documentation and any modifications thereto. Any use, reproduction,
# disclosure or distribution of this material and related documentation
# without an express license agreement from NVIDIA CORPORATION or
# its affiliates is strictly prohibited.

#cython: language_level=3

from pyverbs.providers.mlx5.hws_table cimport HwsTable
from pyverbs.base cimport PyverbsCM, PyverbsObject
cimport pyverbs.providers.mlx5.libmlx5hws as hws


cdef class HwsMatcherAttr(PyverbsObject):
    cdef hws.mlx5dv_hws_matcher_attr attr


cdef class HwsMatcher(PyverbsCM):
    cdef hws.mlx5dv_hws_matcher *matcher
    cdef HwsTable hws_table
    cdef object match_templates
    cdef object action_templates
    cdef object rules
    cdef add_ref(self, obj)
    cdef del_ref(self, obj)


cdef class HwsMatcherMetric(PyverbsObject):
    cdef hws.mlx5dv_hws_metric_matcher metric


cdef class HwsMetricMatcherTemplateAttr(PyverbsCM):
    cdef hws.mlx5dv_hws_metric_matcher_template_attr attr


cdef class HwsMatcherTemplateMetric(PyverbsObject):
    cdef hws.mlx5dv_hws_metric_matcher_template metric
