# Copyright (c) <2024> NVIDIA CORPORATION & AFFILIATES. All rights reserved.
#
# NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
# property and proprietary rights in and to this material, related
# documentation and any modifications thereto. Any use, reproduction,
# disclosure or distribution of this material and related documentation
# without an express license agreement from NVIDIA CORPORATION or
# its affiliates is strictly prohibited.

#cython: language_level=3

from pyverbs.providers.mlx5.hws_context cimport HwsContext
from pyverbs.base cimport PyverbsCM, PyverbsObject
cimport pyverbs.providers.mlx5.libmlx5hws as hws


cdef class HwsParserHeaderFieldConfig(PyverbsObject):
    cdef hws.mlx5dv_hws_parser_field_cfg field_config


cdef class HwsParserHeaderLenConfig(PyverbsObject):
    cdef hws.mlx5dv_hws_parser_hdr_len_cfg len_config


cdef class HwsParserNodeConfig(PyverbsObject):
    cdef hws.mlx5dv_hws_parser_node_cfg config


cdef class HwsParserArcNode(PyverbsObject):
    cdef hws.mlx5dv_hws_parser_arc_node_cfg arc_node


cdef class HwsParserArcConfig(PyverbsObject):
    cdef hws.mlx5dv_hws_parser_arc_cfg config


cdef class HwsParserSamplerConfig(PyverbsObject):
    cdef hws.mlx5dv_hws_parser_sampler_cfg config


cdef class HwsParserGeneveOptionConfig(PyverbsObject):
    cdef hws.mlx5dv_hws_parser_geneve_option_cfg config


cdef class HwsParserGraph(PyverbsCM):
    cdef hws.mlx5dv_hws_parser_graph *graph
    cdef HwsContext hws_context
    cdef object graph_nodes
    cdef object graph_arcs
    cdef add_ref(self, obj)


cdef class HwsParserNode(PyverbsCM):
    cdef hws.mlx5dv_hws_parser_node *node
    cdef object node_samplers
    cdef add_ref(self, obj)


cdef class HwsParserArc(PyverbsCM):
    cdef hws.mlx5dv_hws_parser_arc *arc


cdef class HwsParserSampler(PyverbsCM):
    cdef hws.mlx5dv_hws_parser_sampler *sampler
