# Copyright (c) <2024> NVIDIA CORPORATION & AFFILIATES. All rights reserved.
#
# NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
# property and proprietary rights in and to this material, related
# documentation and any modifications thereto. Any use, reproduction,
# disclosure or distribution of this material and related documentation
# without an express license agreement from NVIDIA CORPORATION or
# its affiliates is strictly prohibited.

#cython: language_level=3

from pyverbs.providers.mlx5.hws_context cimport HwsContext
from pyverbs.base cimport PyverbsCM, PyverbsObject
cimport pyverbs.providers.mlx5.libmlx5hws as hws
from libc.stdint cimport uint32_t


cdef class HwsResourceAttr(PyverbsObject):
    cdef hws.mlx5dv_hws_resource_attr attr


cdef class HwsResourceEnqueueAsoAttr(PyverbsObject):
    cdef hws.mlx5dv_hws_resource_enqueue_aso_attr attr
    cdef object user_data


cdef class HwsResource(PyverbsCM):
    cdef hws.mlx5dv_hws_resource *resource
    cdef HwsContext context
    cdef hws.mlx5dv_devx_obj* ret_obj
    cdef uint32_t ret_obj_id
    cdef object actions
    cdef add_ref(self, obj)
