# Copyright (c) <2024> NVIDIA CORPORATION & AFFILIATES. All rights reserved.
#
# NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
# property and proprietary rights in and to this material, related
# documentation and any modifications thereto. Any use, reproduction,
# disclosure or distribution of this material and related documentation
# without an express license agreement from NVIDIA CORPORATION or
# its affiliates is strictly prohibited.

#cython: language_level=3

from pyverbs.providers.mlx5.hws_context cimport HwsContext, HwsQueueOpResult
from pyverbs.providers.mlx5.hws_matcher cimport HwsMatcher
from pyverbs.providers.mlx5.hws_actions cimport HwsAction
from pyverbs.base cimport PyverbsCM, PyverbsObject
cimport pyverbs.providers.mlx5.libmlx5hws as hws


cdef class HwsRuleQuery(PyverbsObject):
    cdef hws.mlx5dv_hws_rule_query_data query


cdef class HwsRuleAttr(PyverbsObject):
    cdef hws.mlx5dv_hws_rule_attr attr
    cdef object user_data


cdef class HwsRule(PyverbsCM):
    cdef hws.mlx5dv_hws_rule *mlx5dv_hws_rule
    cdef HwsRuleAttr rule_attr_destroy
    cdef HwsAction dest_action
    cdef object res
    cdef HwsContext context
    cdef HwsMatcher matcher

cpdef get_rule_handle_size()
