# Copyright (c) <2024> NVIDIA CORPORATION & AFFILIATES. All rights reserved.
#
# NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
# property and proprietary rights in and to this material, related
# documentation and any modifications thereto. Any use, reproduction,
# disclosure or distribution of this material and related documentation
# without an express license agreement from NVIDIA CORPORATION or
# its affiliates is strictly prohibited.

#cython: language_level=3

from pyverbs.providers.mlx5.hws_context cimport HwsContext
from pyverbs.base cimport PyverbsCM, PyverbsObject
cimport pyverbs.providers.mlx5.libmlx5hws as hws

cdef class HwsTableAttr(PyverbsObject):
    cdef hws.mlx5dv_hws_table_attr attr

cdef class HwsTableInfo(PyverbsObject):
    cdef hws.mlx5dv_hws_metric_table metric


cdef class HwsTable(PyverbsCM):
    cdef hws.mlx5dv_hws_table *table
    cdef HwsContext hws_context
    cdef object hws_matchers
    cdef object hws_actions
    cdef add_ref(self, obj)
