# Copyright (c) <2024> NVIDIA CORPORATION & AFFILIATES. All rights reserved.
#
# NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
# property and proprietary rights in and to this material, related
# documentation and any modifications thereto. Any use, reproduction,
# disclosure or distribution of this material and related documentation
# without an express license agreement from NVIDIA CORPORATION or
# its affiliates is strictly prohibited.

#cython: language_level=3

cdef extern from 'infiniband/mlx5dv_hws.h':

    cpdef enum mlx5dv_hws_table_type:
        MLX5DV_HWS_TABLE_TYPE_NIC_RX
        MLX5DV_HWS_TABLE_TYPE_NIC_TX
        MLX5DV_HWS_TABLE_TYPE_RDMA_TRANSPORT_RX
        MLX5DV_HWS_TABLE_TYPE_RDMA_TRANSPORT_TX
        MLX5DV_HWS_TABLE_TYPE_FDB_RX
        MLX5DV_HWS_TABLE_TYPE_FDB_TX
        MLX5DV_HWS_TABLE_TYPE_FDB
        MLX5DV_HWS_TABLE_TYPE_MAX

    cpdef enum mlx5dv_hws_field_name:
        MLX5DV_HWS_FNAME_L3_TYPE
        MLX5DV_HWS_FNAME_L4_TYPE
        MLX5DV_HWS_FNAME_ETH_TYPE
        MLX5DV_HWS_FNAME_SMAC_47_16
        MLX5DV_HWS_FNAME_SMAC_15_0
        MLX5DV_HWS_FNAME_DMAC_47_16
        MLX5DV_HWS_FNAME_DMAC_15_0
        MLX5DV_HWS_FNAME_FIRST_PRIO
        MLX5DV_HWS_FNAME_FIRST_CFI
        MLX5DV_HWS_FNAME_FIRST_VID
        MLX5DV_HWS_FNAME_FIRST_CVLAN
        MLX5DV_HWS_FNAME_FIRST_SVLAN
        MLX5DV_HWS_FNAME_SECOND_PRIO
        MLX5DV_HWS_FNAME_SECOND_CFI
        MLX5DV_HWS_FNAME_SECOND_VID
        MLX5DV_HWS_FNAME_SECOND_CVLAN
        MLX5DV_HWS_FNAME_SECOND_SVLAN
        MLX5DV_HWS_FNAME_IP_VERSION
        MLX5DV_HWS_FNAME_IP_FRAG
        MLX5DV_HWS_FNAME_IP_SPORT
        MLX5DV_HWS_FNAME_IP_DPORT
        MLX5DV_HWS_FNAME_IP_TCP_SPORT
        MLX5DV_HWS_FNAME_IP_TCP_DPORT
        MLX5DV_HWS_FNAME_IP_TCP_FLAGS
        MLX5DV_HWS_FNAME_IP_UDP_SPORT
        MLX5DV_HWS_FNAME_IP_UDP_DPORT
        MLX5DV_HWS_FNAME_IPV4_LEN
        MLX5DV_HWS_FNAME_IPV4_SRC
        MLX5DV_HWS_FNAME_IPV4_DST
        MLX5DV_HWS_FNAME_IPV6_DST_127_96
        MLX5DV_HWS_FNAME_IPV6_DST_95_64
        MLX5DV_HWS_FNAME_IPV6_DST_63_32
        MLX5DV_HWS_FNAME_IPV6_DST_31_0
        MLX5DV_HWS_FNAME_IPV6_SRC_127_96
        MLX5DV_HWS_FNAME_IPV6_SRC_95_64
        MLX5DV_HWS_FNAME_IPV6_SRC_63_32
        MLX5DV_HWS_FNAME_IPV6_SRC_31_0
        MLX5DV_HWS_FNAME_REG_C0
        MLX5DV_HWS_FNAME_REG_C1
        MLX5DV_HWS_FNAME_REG_C2
        MLX5DV_HWS_FNAME_REG_C3
        MLX5DV_HWS_FNAME_REG_C4
        MLX5DV_HWS_FNAME_REG_C5
        MLX5DV_HWS_FNAME_REG_C6
        MLX5DV_HWS_FNAME_REG_C7
        MLX5DV_HWS_FNAME_REG_C8
        MLX5DV_HWS_FNAME_REG_C9
        MLX5DV_HWS_FNAME_REG_C10
        MLX5DV_HWS_FNAME_REG_C11
        MLX5DV_HWS_FNAME_REG_A
        MLX5DV_HWS_FNAME_REG_B
        MLX5DV_HWS_FNAME_FLEX_PARSER_0
        MLX5DV_HWS_FNAME_FLEX_PARSER_1
        MLX5DV_HWS_FNAME_FLEX_PARSER_2
        MLX5DV_HWS_FNAME_FLEX_PARSER_3
        MLX5DV_HWS_FNAME_FLEX_PARSER_4
        MLX5DV_HWS_FNAME_FLEX_PARSER_5
        MLX5DV_HWS_FNAME_FLEX_PARSER_6
        MLX5DV_HWS_FNAME_FLEX_PARSER_7
        MLX5DV_HWS_FNAME_FLEX_PARSER_0_OK
        MLX5DV_HWS_FNAME_FLEX_PARSER_1_OK
        MLX5DV_HWS_FNAME_FLEX_PARSER_2_OK
        MLX5DV_HWS_FNAME_FLEX_PARSER_3_OK
        MLX5DV_HWS_FNAME_FLEX_PARSER_4_OK
        MLX5DV_HWS_FNAME_FLEX_PARSER_5_OK
        MLX5DV_HWS_FNAME_FLEX_PARSER_6_OK
        MLX5DV_HWS_FNAME_FLEX_PARSER_7_OK
        MLX5DV_HWS_FNAME_SOURCE_QP
        MLX5DV_HWS_FNAME_RANDOM_NUM

    cpdef enum mlx5dv_hws_field_header:
        MLX5DV_HWS_HEADER_NONE
        MLX5DV_HWS_HEADER_OUTER
        MLX5DV_HWS_HEADER_INNER
        MLX5DV_HWS_HEADER_MAX

    cpdef enum mlx5dv_hws_field_match_op:
        MLX5DV_HWS_FIELD_MATCH_OP_EQ
        MLX5DV_HWS_FIELD_MATCH_OP_NE
        MLX5DV_HWS_FIELD_MATCH_OP_LT
        MLX5DV_HWS_FIELD_MATCH_OP_LE
        MLX5DV_HWS_FIELD_MATCH_OP_GT
        MLX5DV_HWS_FIELD_MATCH_OP_GE

    cpdef enum mlx5dv_hws_field_match_type:
        MLX5DV_HWS_FIELD_MATCH_TYPE_TO_VALUE
        MLX5DV_HWS_FIELD_MATCH_TYPE_TO_FIELD

    cpdef enum mlx5dv_hws_field_user_conv_flag:
        MLX5DV_HWS_FIELD_USER_CONV_FLAG_MATCH
        MLX5DV_HWS_FIELD_USER_CONV_FLAG_MASK
        MLX5DV_HWS_FIELD_USER_CONV_FLAG_LAST

    cpdef enum mlx5dv_hws_matcher_resource_mode:
        MLX5DV_HWS_MATCHER_RESOURCE_MODE_RULE
        MLX5DV_HWS_MATCHER_RESOURCE_MODE_HTABLE

    cpdef enum mlx5dv_hws_matcher_insert_mode:
        MLX5DV_HWS_MATCHER_INSERT_BY_HASH
        MLX5DV_HWS_MATCHER_INSERT_BY_INDEX

    cpdef enum mlx5dv_hws_matcher_distribute_mode:
        MLX5DV_HWS_MATCHER_DISTRIBUTE_BY_HASH
        MLX5DV_HWS_MATCHER_DISTRIBUTE_BY_LINEAR

    cpdef enum mlx5dv_hws_resource_type:
        MLX5DV_HWS_RESOURCE_TYPE_ASO_COUNTER
        MLX5DV_HWS_RESOURCE_TYPE_ASO_CONNTRACK
        MLX5DV_HWS_RESOURCE_TYPE_ASO_FLOW_HIT
        MLX5DV_HWS_RESOURCE_TYPE_ASO_METER
        MLX5DV_HWS_RESOURCE_TYPE_ARGUMENT_64B
        MLX5DV_HWS_RESOURCE_TYPE_ARGUMENT_128B
        MLX5DV_HWS_RESOURCE_TYPE_ARGUMENT_256B

    cpdef enum mlx5dv_hws_queue_op_status:
        MLX5DV_HWS_QUEUE_OP_SUCCESS
        MLX5DV_HWS_QUEUE_OP_ERROR

    cpdef enum mlx5dv_hws_action_flags:
        MLX5DV_HWS_ACTION_FLAG_NIC_RX
        MLX5DV_HWS_ACTION_FLAG_NIC_TX
        MLX5DV_HWS_ACTION_FLAG_RDMA_TRANSPORT_RX
        MLX5DV_HWS_ACTION_FLAG_RDMA_TRANSPORT_TX
        MLX5DV_HWS_ACTION_FLAG_FDB_RX
        MLX5DV_HWS_ACTION_FLAG_FDB_TX
        MLX5DV_HWS_ACTION_FLAG_FDB
        MLX5DV_HWS_ACTION_FLAG_ROOT

    cpdef enum mlx5dv_hws_queue_op:
        MLX5DV_HWS_QUEUE_OP_DRAIN_ASYNC
        MLX5DV_HWS_QUEUE_OP_DRAIN_SYNC

    cpdef enum mlx5dv_hws_metric_flag:
        MLX5DV_HWS_METRIC_FLAG_INFO
        MLX5DV_HWS_METRIC_FLAG_COST
        MLX5DV_HWS_METRIC_FLAG_RESOURCE

    cpdef enum mlx5dv_hws_parser_hdr_len_mode:
        MLX5DV_HWS_PARSER_HDR_LEN_MODE_FIXED
        MLX5DV_HWS_PARSER_HDR_LEN_MODE_FIELD

    cpdef enum mlx5dv_hws_parser_node_type:
        MLX5DV_HWS_PARSER_NODE_TYPE_NATIVE
        MLX5DV_HWS_PARSER_NODE_TYPE_FLEX

    cpdef enum mlx5dv_hws_parser_native_node:
        MLX5DV_HWS_PARSER_NATIVE_NODE_MAC
        MLX5DV_HWS_PARSER_NATIVE_NODE_IP
        MLX5DV_HWS_PARSER_NATIVE_NODE_GRE
        MLX5DV_HWS_PARSER_NATIVE_NODE_UDP
        MLX5DV_HWS_PARSER_NATIVE_NODE_MPLS
        MLX5DV_HWS_PARSER_NATIVE_NODE_TCP
        MLX5DV_HWS_PARSER_NATIVE_NODE_VXLAN_GPE
        MLX5DV_HWS_PARSER_NATIVE_NODE_GENEVE
        MLX5DV_HWS_PARSER_NATIVE_NODE_IPSEC_ESP
        MLX5DV_HWS_PARSER_NATIVE_NODE_IPV4
        MLX5DV_HWS_PARSER_NATIVE_NODE_IPV6
        MLX5DV_HWS_PARSER_NATIVE_NODE_NISP

    cpdef enum mlx5dv_hws_action_aso_meter_color:
        MLX5DV_HWS_ACTION_ASO_METER_COLOR_RED
        MLX5DV_HWS_ACTION_ASO_METER_COLOR_YELLOW
        MLX5DV_HWS_ACTION_ASO_METER_COLOR_GREEN
        MLX5DV_HWS_ACTION_ASO_METER_COLOR_UNDEFINED

    cpdef enum mlx5dv_hws_action_aso_ct_direction:
        MLX5DV_HWS_ACTION_ASO_CT_DIRECTION_INITIATOR
        MLX5DV_HWS_ACTION_ASO_CT_DIRECTION_RESPONDER

    cpdef enum mlx5dv_hws_action_remove_header_type:
        MLX5DV_HWS_ACTION_REMOVE_HEADER_TYPE_BY_OFFSET
        MLX5DV_HWS_ACTION_REMOVE_HEADER_TYPE_BY_HEADER

    cpdef enum mlx5dv_hws_action_dest_reformat_type:
        MLX5DV_HWS_ACTION_DEST_REFORMAT_TYPE_NONE
        MLX5DV_HWS_ACTION_DEST_REFORMAT_TYPE_L2_TO_TNL_L2
        MLX5DV_HWS_ACTION_DEST_REFORMAT_TYPE_L2_TO_TNL_L3

    cpdef enum mlx5dv_hws_action_dest_matcher_type:
        MLX5DV_HWS_ACTION_DEST_MATCHER_BY_INDEX
